using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace TestApp
{
    public partial class Form1 : Form
    {
        private StockCache stockCache;
        private Random rnd = new Random();
        private Random rnd1 = new Random();

        public Form1()
        {
            InitializeComponent();
            SetStockCache();
            SetGrid();
        }

        private void SetStockCache()
        {
            stockCache = new StockCache();
            for (int i = 0; i < 10; i++)
            {
                stockCache.Add(i, new Stock(i));
            }            
        }

        private void SetGrid()
        {
            this.gridGroupingControl1.DataSource = stockCache;            
            this.Dock = DockStyle.Fill;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Timer t = new Timer();
            t.Interval = 10;
            t.Tick += new EventHandler(t_Tick);
            t.Start();
        }

        private void t_Tick(object sender, EventArgs e)
        {
            this.gridGroupingControl1.TableControl.BeginUpdate(); 
            int n = rnd.Next(stockCache.Count);
            int p = rnd1.Next(2);
            stockCache[n].Price += Math.Pow(-1,p)* Math.Round(rnd.NextDouble() * 2);
            ListChangedEventArgs el = new ListChangedEventArgs(ListChangedType.ItemChanged,n);
            this.gridGroupingControl1.Table.SimulateListChanged(el);
            this.gridGroupingControl1.TableControl.EndUpdate(true); 
        }       
    }
}